# The labels of primary or metastasis were permutated 100 times to calculate a
# false-discovery rate for each gene.

for(j in 1:permutations){
	#primMet is the label of either primary or metastasis labels<-sample(1:length(primMet))
	#ran lmer in parallel on all genes using apply function
	test <- apply(
		RNA[,labels],
		1,
		function(x){
			ao <- summary(lmer(as.numeric(x) ~ primMet + (1|patient)));
			return(ao$coefficients[2,3])
		}
	)
	ps <- cbind(ps,test)
}

#calculated the FDR by counting the number of times the permutated P value
#was lower than the originally calculated t statistic. thresh<- quantile(abs(original.T),seq(0,1,0.02))
actCount <- sapply(
	thresh,
	function(x,y){
		sum(abs(y)>x)
	},
	original.T
)
permCount <- sapply(
	thresh,
	function(x,y){
		sum(abs(y)>x)
	},
	as.numeric(ps))/100
	dtable <- data.frame(thresh,actCount,permCount,fdr=round(permCount/actCount,3)
)
qs <- unlist(
	lapply(
		original.T,
		function(x){
			row <- min(which(dtable[,1] >= abs(x))) + 1
			return(dtable[row,4])
		}
	)
)
